ball = {}
local bm = {__index = ball}

function ball.new(orbit_x, orbit_y, orbit_radius, orbit_speed, radius, angle, color)
	angle = angle or 0
	color = color or {255, 255, 126, }
	local b = {
		x = 0,
		y = 0,
		center = {x = orbit_x, y = orbit_y},
		orbit_radius = orbit_radius,
		orad = orbit_radius,
		orbit_speed = orbit_speed,
		radius = radius,
		dradius  = radius,
		angle = angle,
		color = color,
		tick = angle
	}
	return setmetatable(b, bm)
end

function ball:update(dt)
	self.angle = self.angle + self.orbit_speed * dt
	if self.angle > (math.pi * 2) then self.angle = 0 end
	if self.angle < 0 then self.angle = math.pi * 2 end

	self.tick = self.tick + (dt / 4)
	self.dradius = (self.radius * math.abs(math.cos(self.tick)))

	self.x = math.cos(self.angle) * self.orbit_radius + self.center.x
	self.y = math.sin(self.angle) * self.orbit_radius + self.center.y
end

function ball:draw()
	love.graphics.setBlendMode("additive")
	love.graphics.setColor(hsl(self.color[1], self.color[2], self.color[3], self.color[4]))
	love.graphics.circle("fill", self.x, self.y, self.dradius)
	local a = self.color[4] * 4
	if a > 255 then a = 255 end
	love.graphics.setColor(hsl(self.color[1], self.color[2], self.color[3], a))
	--love.graphics.circle("line", self.x, self.y, self.dradius)
end

function ball:get()
	return self
end